#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct QueueEntry {
  char *name;
  struct QueueEntry *next;
};

struct QueueEntry *qhead, *qtail;

void enqueue(char *name) {
  struct QueueEntry *qe = malloc(sizeof(struct QueueEntry));
  qe->next = malloc(sizeof(struct QueueEntry));
  qe->name = malloc(strlen(name)+1);
  strcpy(qe->name, name);
  if(qtail)
    qtail->next = qe;
  else
    qtail = qe;
  if(!qhead)
    qhead = qe; 
}

char *dequeue() {
  if(qhead) {
    char *name = qhead->name;
    free(qhead);
    free(qhead->name);
    free(qhead->next);
    if(qhead == qtail)
      qtail = 0;
    qhead = qhead->next;
    return name;
  } else
    return 0;
}

void printqueue() {
  struct QueueEntry *qep = qhead;
  while(qep) {
    printf("%s\n",qep->name);
    qep = qep->next;
  }
}

void usage() {
  printf("usage:\n"
   " d   Dequeue\n"
   " e   Enqueue\n"
   " f   Dequeue all\n"
   " p   Print queue contents\n"
   " q   Quit\n");
}

int main() {
  char buf[256];
  usage();
  for(;;) {
    printf("queue command: ");
    fgets(buf, 256, stdin);
    switch(buf[0]) {
    case 'e':
      printf("String to enqueue: ");
      fgets(buf, 256, stdin);
      buf[strlen(buf)-1] = 0;
      enqueue(buf);
      break;
    case 'd': {
       char *s = dequeue();
       if(s)
         printf("%s\n",s);
       else
         printf("Queue empty!\n");
      }
      break;
    case 'f': {
       char *s;
       while(s = dequeue())
        printf("%s\n", s);
      }
      break;
    case 'p':
      printqueue();
      break;
    case 'q':
      return 0;
    default:
      printf("invalid command\n");
      usage();
    }
  }
}
